



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>I/O重定向的原理和实现</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">I/O重定向的原理和实现</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-21 20:46:28 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>在Unix系统中，每个进程都有STDIN、STDOUT和STDERR这3种标准I/O，它们是程序最通用的输入输出方式。几乎所有语言都有相应的标准I/O函数，比如，C语言可以通过scanf从终端输入字符，通过printf向终端输出字符。熟悉Shell的朋友都知道，我们可以方便地对Shell命令进行I/O重定向，比如 <code>find -name "*.java" &gt;testfile.txt</code> 把当前目录下的Java文件列表重定向到testfile.txt。多数情况下，我们只需要了解I/O重定向的使用就够了，但是如果要编程实现类似Shell的I/O重定向以及管道功能，那么就需要清楚它的原理和实现。</p>
<p>下面本文就以Linux系统为具体例子，介绍I/O重定向的原理和实现（文中实验环境为Ubuntu 12.04，内核版本3.2.0-59）。</p>
<h2>文件描述符表</h2>
<p>理解I/O重定向的原理需要从Linux内核为进程所维护的关键数据结构入手。对Linux进程来讲，每个打开的文件都是通过文件描述符(File Descriptor)来标识的，内核为每个进程维护了一个文件描述符表，这个表以FD为索引，再进一步指向文件的详细信息。在进程创建时，内核为进程默认创建了0、1、2三个特殊的FD，这就是STDIN、STDOUT和STDERR，如下图所示意：</p>
<p><img referrerpolicy="no-referrer"src="http://cs.ucla.edu/classes/fall08/cs111/scribe/4/FDT_diagram.JPG" /></p>
<p>所谓的I/O重定向也就是让已创建的FD指向其他文件。比如，下面是对STDOUT重定向到testfile.txt前后内核文件描述符表变化的示意图</p>
<p>重定向前：</p>
<p><img referrerpolicy="no-referrer"src="http://academic.udayton.edu/SaverioPerugini/courses/cps346/lecture_notes/images/beforeredir.png" /></p>
<p>重定向后：</p>
<p><img referrerpolicy="no-referrer"src="http://academic.udayton.edu/SaverioPerugini/courses/cps346/lecture_notes/images/afterredir.png" /></p>
<p>在I/O重定向的过程中，<strong>不变的是FD 0/1/2代表STDIN/STDOUT/STDERR，变化的是文件描述符表中FD 0/1/2对应的具体文件</strong>，应用程序只关心前者。本质上这和接口的原理是相通的，通过一个间接层把功能的使用者和提供者解耦。</p>
<p>下面我们通过strace命令跟踪一下echo命令的系统调用：</p>
<pre class="prettyprint linenums"><code>dagang@ubuntu12:~$ strace echo hello 2&gt;&amp;1 &gt;/dev/null | grep write<br />
write(1, "hello\n", 6)                  = 6<br />
</code></pre>
<p>我们可以看到 <code>write(1, "hello\n", 6)</code> 这样一个系统调用，它的第一个参数1就是代表的STDOUT的FD，这说明对于echo程序，它只管（通过标准I/O函数从STDOUT）向FD 1写入，而不关心它们FD 1到底对应的是哪个文件。</p>
<p>Shell正是通过I/O重定向和管道这种特殊的文件把多个程序的STDIN和STDOUT串联在一起组成更复杂功能的，下面是Shell中通过管道的示意图：</p>
<p><img referrerpolicy="no-referrer"src="http://upload.wikimedia.org/wikipedia/commons/thumb/f/f6/Pipeline.svg/280px-Pipeline.svg.png" /></p>
<p>下面我们用一个实际的例子来体验一下：</p>
<pre class="prettyprint linenums"><code>dagang@ubuntu12:~$ sleep 30 | sleep 40 &amp;<br />
[1] 5584<br />
dagang@ubuntu12:~$ pgrep -l sleep<br />
5583 sleep<br />
5584 sleep<br />
dagang@ubuntu12:~$ ll /proc/5583/fd<br />
total 0<br />
lrwx------ 1 dagang dagang 64 Feb 27 13:41 0 -&gt; /dev/pts/3<br />
l-wx------ 1 dagang dagang 64 Feb 27 13:41 1 -&gt; pipe:[246469]<br />
lrwx------ 1 dagang dagang 64 Feb 27 13:41 2 -&gt; /dev/pts/3<br />
dagang@ubuntu12:~$ ll /proc/5584/fd<br />
total 0<br />
lr-x------ 1 dagang dagang 64 Feb 27 13:41 0 -&gt; pipe:[246469]<br />
lrwx------ 1 dagang dagang 64 Feb 27 13:41 1 -&gt; /dev/pts/3<br />
lrwx------ 1 dagang dagang 64 Feb 27 13:41 2 -&gt; /dev/pts/3<br />
</code></pre>
<p>上面我们启动了两个进程5583和5584，通过查看/proc//fd，我们看到进程5583的STDOUT和5584的STDIN被重定向到了pipe:[246469]，这样就达到了连接两个进程标准I/O的目的。</p>
<h2>dup2()系统调用</h2>
<p>上面介绍了文件描述符表和I/O重定向的原理，那么在Linux系统中如何通过C程序实现I/O重定向呢？主要用到了dup2()这个系统调用，man中关于dup2是这样说的：</p>
<blockquote><p>int dup2(int oldfd, int newfd);</p>
<p>dup2() create a copy of the file descriptor oldfd. After a successful return from dup() or dup2(), the old and new file descriptors may be used interchangeably. They refer to the  same  open file description (see open(2)) and thus share file offset and file status flags; for example, if the file offset is modified by using lseek(2) on one of the descriptors, the offset is also changed for the other.</p></blockquote>
<p>这里我们通过一个实际的问题来说明它的使用方法：</p>
<blockquote><p>编写一个C程序，通过调用sort这个Shell命令进行排序，要求把in.txt和out.txt分别重定向到sort的STDIN，STDOUT。</p></blockquote>
<p>参考实现：</p>
<pre class="prettyprint linenums"><code>int main() {<br />
    int pid = 0;<br />
    // fork a worker process<br />
    if (pid = fork()) {<br />
        // wait for completion of the child process<br />
        int status;<br />
        waitpid(pid, &amp;status, 0);<br />
    }<br />
    else {<br />
        // open input and output files<br />
        int fd_in = open("in.txt", O_RDONLY);<br />
        int fd_out = open("out.txt", O_CREAT | O_RDWR, S_IRUSR | S_IWUSR | S_IRGRP | S_IROTH);<br />
        if (fd_in &gt; 0 &amp;&amp; fd_out &gt; 0) {<br />
            // redirect STDIN/STDOUT for this process<br />
            dup2(fd_in, 0);<br />
            dup2(fd_out, 1);<br />
            // call shell command<br />
            system("sort");<br />
            close(fd_in);<br />
            close(fd_out);<br />
        }<br />
        else {<br />
            // ... error handling<br />
        }<br />
    }<br />
    return 0;<br />
}<br />
</code></pre>
<p>上面的主要步骤包括：</p>
<p>1. 首先fork一个子进程，后续步骤都在子进程中完成，父进程通过waitpid()系统调用等待子进程结束；<br />2. 打开open()系统调用打开in.txt和out.txt，得到它们的描述符（在我的测试中，这两个值通常为3和4）；<br />3. 通过dup2()系统调用把STDIN重定向到fd_in，把STDOUT重定向到fd_out（注意，重定向的影响范围是整个子进程）；<br />4. 通过system()系统调用运行shell命令sort</p>
<p>通过上面的例子我们就了解最基本的I/O重定向的实现方法，接下来，你能否根据这些知识进一步实现出Shell的管道特性呢？</p>
<h2>总结</h2>
<p>本文介绍了Linux系统I/O重定向的原理和实现方式。原理方法最重要的是理解文件描述符和文件描述符表的概念，以及标准I/O所对应的特殊FD；实现方面主要是了解dup2()系统调用的功能和用法。最后需要注意的是dup2()不仅可以用来对标准I/O重定向，对任何FD都是可以的，这是习惯使用Shell进行标准I/O重定向的朋友容易忽略的。</p>
<h2>图片引用</h2>
<p><a href="http://cs.ucla.edu/classes/fall08/cs111/scribe/4/FDT_diagram.JPG" rel="external nofollow noreferrer">http://cs.ucla.edu/classes/fall08/cs111/scribe/4/FDT_diagram.JPG</a><br /><a href="http://academic.udayton.edu/SaverioPerugini/courses/cps346/lecture_notes/images/beforeredir.png" rel="external nofollow noreferrer">http://academic.udayton.edu/SaverioPerugini/courses/cps346/lecture_notes/images/beforeredir.png</a><br /><a href="http://academic.udayton.edu/SaverioPerugini/courses/cps346/lecture_notes/images/afterredir.png" rel="external nofollow noreferrer">http://academic.udayton.edu/SaverioPerugini/courses/cps346/lecture_notes/images/afterredir.png</a><br /><a href="http://upload.wikimedia.org/wikipedia/commons/thumb/f/f6/Pipeline.svg/280px-Pipeline.svg.png" rel="external nofollow noreferrer">http://upload.wikimedia.org/wikipedia/commons/thumb/f/f6/Pipeline.svg/280px-Pipeline.svg.png</a></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/r93rl0w9.html">如何清除windows 用户名及密码</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxm32j9.html">函数指针的一个demo</a>
		</li>
						<li><a href="https://www.batexi.com/a/3903p739.html">mysql 不允许连接</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdjk4y8.html">C-union的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1ownr9.html">如何使用css和jquery控制文章标题字数？</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okdpol9.html">java读写中文文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7m3gvxq.html">如何在 Windows 7 安裝 SharePoint Server 2010</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vo1v38.html">tempo 2&period;0 学习记录</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vwdx38.html">JS学习笔记（一）基本数据类型和对象类型</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pj17zd9.html">poj 2688 Cleaning Robot bfs&plus;dfs</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1jd3gq.html">UseCase事件流描述规范</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyownv9.html">testXSS &amp;lt&semi;img src&equals;&amp;quot&semi;aa&amp;quot&semi; onerror&equals;&amp;quot&semi;javascript&colon;alert&lpar;&amp;&num;39&semi;XSS&amp;&num;39&semi;&rpar;&semi;&amp;quot&semi;&sol;&amp;gt&semi;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjrm6e9.html">java Integer类以及拆箱和装箱</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e47xzm9.html">Fragment与Activity之间的相互通信</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7o6wn18.html">善于利用python中的os模块</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ppwlgk9.html">vivado中设置多线程编译</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql11dp69.html">Mybatis系列&lpar;四&rpar;：Mybatis缓存</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdjdv0jq.html">java中拼写xml</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mj7k568.html">总结开发中使用到的npm 库</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o40pk5q.html">du熊的机器人</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/xq4z2p59.html">CommonJS&comma; AMD 和 RequireJS之间的关系&lpar;转载&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqdp3mjq.html">echarts之tooltip-showContent</a>
			</li>
						<li><a href="https://www.batexi.com/a/39rgrze8.html">c3p0 连接池</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q2jplo8.html">无法加载 DLL&OpenCurlyDoubleQuote;SQLite&period;Interop&period;dll&rdquo;&colon; 找不到指定的模块。 &lpar;异常来自 HRESULT&colon;0x8007007E&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqv1461q.html">Cloud Engine：大杀器如何炼成</a>
			</li>
						<li><a href="https://www.batexi.com/a/49geolz8.html">Docker Volume 之权限管理&lpar;转&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8kpx359.html">rpm 看 rpm 包内容</a>
			</li>
						<li><a href="https://www.batexi.com/a/39rge0d8.html">&lbrack;field&colon;picname&sol;&rsqb;和&lbrack;field&colon;litpic&sol;&rsqb;区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqdpmn7q.html">jQuery extend扩展String原型</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qy1pp2q.html">Android 怎么退出整个应用程序？</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
